package org.blue.club.entities.dto;

import com.mybatisflex.annotation.Id;
import com.mybatisflex.annotation.RelationManyToOne;
import jakarta.annotation.Nullable;
import lombok.Data;
import org.blue.club.entities.vo.AuthVo;
import org.blue.club.entities.vo.ClubVo;
import org.mmga.spring.boot.starter.interfaces.IdHolder;

@Data
public class User implements IdHolder {
    @Id
    private Long id;
    private String name;
    @Nullable
    private String avatar;
    private AuthVo auths;
    private ClubVo club;
    private AuthVo clubAuth;

    public boolean hasPermission(Long permissionId) {
        return (clubAuth != null && clubAuth.hasPermission(permissionId)) || (auths != null && auths.hasPermission(permissionId));
    }

    public boolean isAuth(Long authId) {
        return (auths != null && authId.equals(auths.getId())) || (clubAuth != null && authId.equals(clubAuth.getId()));
    }
}
